/**
  Un algoritm neoptim ar consta in generarea tuturor nr.
de 5 cifre, shi verificarea daca acestea respecta conditziile
date.
  Nr. de pashi ar fi f. mare: 90000

Algoritmul optim consta in:
 - generarea pentru cifrele a shi d DOAR a valorilor
 permise, plecind de la observatzia ca a poate pleca minim
 de la 1, insa daca s este mai mare decit 11, a va pleca
 de la valori mai mari
   In general:
      a poate lua ca domeniu de valori:
      [max(s1-9,1);min(s1,9)]
    b = s1-a
c poate fi orice cifra intre 0 shi 9
d poate lua va val. [max(s2-9,0);min(s2,9)]
e = s2-d

Acest lucru se programeaza pe 3 for-uri imbricate.

Nr. de pashi poate fi maxim 9*10*10 = 900
(pe cazul cel mai defavorabil)

comparativ cu primul algoritm, ashadar, pentru acesta
timpul de executare este mai scurt.
*/
#include <iostream>
#include <fstream>
using namespace std;

int main()
{
    ofstream fout("bac.txt");
    int s1,s2,a,b,c,d,e,lia,lfa,lid,lfd;
    cin>>s1>>s2;
    if(s1-9>1)lia=s1-9;
    else lia=1;
    if(s1<9)lfa=s1;
       else lfa=9;
    if(s2-9>0)lid=s2-9;
         else lid=0;
    if(s2<9)lfd=s2;
       else lfd=9;
    for(a=lia;a<=lfa;a++)
    {
        b=s1-a;
        for(c=0;c<=9;c++)
            for(d=lid;d<=lfd;d++)
                {
                    e=s2-d;
                    fout<<a<<b<<c<<d<<e<<"\n";
                }
    }
    fout.close();
    return 0;
}
