/**
 b) Plecind de la observatzia ca shirul este sortat, algoritmul
optim se bazeaza pe cautarea binara.
  Vom citi numerele intr-un vector (fara acest lucru NU am
putea rezolva problema printr-o singura parcurgere a fishierului,
deoarece capetele intervalului [a,b] sunt date la final. - daca
am parcurge fishierul de 2 ori ar fi total neoptim ca timp
de executare, deoarece accesarea fishierelor dureaza de mii de ori
mai mult decit a memoriei).
  Odata citite shirul shi capetele a,b, facem cautare binara
a lui a in vector.
  Daca este gasit => solutzia este chiar el.

  Daca nu, alg. cautarii binare s-a oprit la 2 indici
la care sunt elemente care ne-ar incadra valoric a-ul,
shi anume a[lf]<a<a[li]
  Cel care ne intereseaza este a[li].
  Verif. mai intii daca acest a[li] exista (li<=n). Daca nu =>nu
avem solutzie
  Daca da, verif. daca a[li]<=b. Daca da -> solutzia este el.
  Daca nu -> NU avem solutzie.

  Algoritmul este eficient d.p.d.v. al timpului de executare
deoarece, dupa citirea datelor din fishier se fac maxim
log n pashi (conform cautarii binare).
*/
#include <iostream>
#include <fstream>
using namespace std;

int main()
{
    int v[30001],a,b,li,lf,n,m,i;
    ifstream fin("bac.txt");
    fin>>n;
    for(i=1;i<=n;i++)
        fin>>v[i];
    fin>>a>>b;
    fin.close();
    li=1;lf=n;
    m=(li+lf)/2;
    while(li<=lf && v[m]!=a)
        {
            if(a<v[m])
                lf=m-1;
            else
                li=m+1;
            m=(li+lf)/2;
        }
    if(li<=lf)
        cout<<a;
    else
        if(li<=n && v[li]<=b)
                        cout<<v[li];
                else cout<<"NU";
    return 0;
}
