/**
 Numerele de pe a doua linie le citim intr-un vector (altfel NU
se poate) insa pe cele de pe linia a 3a le prelucram in timpul
citirii.
  Astfel:
  - mentzinem in 2 variabile [a,b] capetele intervalului curent
  - mentzinem un indice in shirul cu numerele de pe linia a 2a
    a fishierului.

Initzial sarim peste acele numere din shir mai mici strict decit a
   Apoi, in functzie de pozitzia nr. curent fatza de intervalul [a,b]
actualizam nr. de valori respectiv capetele intervalului, calculind
un maxim in functzie de nr. total de valori.

  Alg este eficient d.p.d.v. al memoriei deoarece nu utilizam
decit un vector (in timp ce datele de intrare sunt formate din
doua shiruri).
  Este eficient ca timp de executare deoarece se parcurg o singura
data datele de intrare (abstractzie facind de citirea shirului
de pe linia a doua) ordinul de complexitate fiind O(n+m)
*/
#include <iostream>
#include <fstream>
using namespace std;

int main()
{
    ifstream fin("bac.dat");
    int i,j,n,m,v[1001],a,b,amax,bmax,nmax=0,nr=0;
    fin>>n>>m;
    for(i=1;i<=n;i++)
        fin>>v[i];
    fin>>a>>b;
    i=1;j=2;
    while(v[i]<a)i++;//sarim peste eventualele valori <a
    while(i<=n&&j<=m)
    {
        if(v[i]<=b) nr++;
        if(nr>nmax){nmax=nr;amax=a;bmax=b;}
        if(v[i]>=b)
            {
                j++;
                if(j<=m) {a=b;fin>>b;}
                nr=0;
            }
        else i++;
    }
    cout<<amax<<" "<<bmax;
    return 0;
}
