/**
  Generarea permutarilor multzimii {1,2,..,n}
(permutari = multzimi ordonate, adica pentru care
    conteaza ordinea scrierii elementelor)
Ex:
n=4
1 2 3 4      2 1 3 4      3 1 2 4     4 1 2 3
1 2 4 3      2 1 4 3      3 1 4 2     4 1 3 2
1 3 2 4      2 3 1 4      3 2 1 4     4 2 1 3
1 3 4 2      2 3 4 1      3 2 4 1     4 2 3 1
1 4 2 3      2 4 1 3      3 4 1 2     4 3 1 2
1 4 3 2      2 4 3 1      3 4 2 1     4 3 2 1

Ele sunt in numar de n!

Analiza pb:
 1) shirul de solutzii este gata pus sub forma de vector
     domenii: x[k] apartzine 1..n

 2) Cond. de valid : x[k] sa fie diferite de x[i], cu i = 1,k-1

 3) Cond. de solutzie : k==n

 4) Fara prelungire
*/
#include <iostream>
using namespace std;

int x[30],n;

int valid(int k)
{
    int i;
    for(i=1;i<k;i++)if(x[k]==x[i])return 0;
    return 1;
}

void afish()
{
    int i;
    for(i=1;i<=n;i++)
      cout<<x[i]<<" ";
    cout<<"\n";
}

void back(int k)
{
  for(x[k]=1 ; x[k]<=n ; x[k]++)
	if(valid(k))
	{
       if(k==n)
			afish();
       else
            back(k+1);
     }
}
int main()
{
    cin>>n;
    back(1);
    return 0;
}
