/**
  Optimizarea generarii partitziilor:
    Mentzinem intr-un parametru pe care-l adaugam la functzia de
back (fie el sum) suma elementelor de pina la momentul de fatza.
  Adica, la intrarea pe nivelul k ne bazam ca in parametrul sum
gasim deja suma
  sum=x[1]+x[2]+...+x[k-1]

  Un avantaj al recursivitatzii este ca, facind un apel de genu'
      recursiv(.., sum+alpha);
-> la intrarea pe nivelul urmator, parametrul sum va avea
valoarea crescuta cu alpha, iar la intoarcere ishi revine la
valoarea de dinainte de adunare.

 optimizarea va fi adusa domeniilor, shi anume, shtiind ca suma alora
de dinainte este sum, domeniul lui x[k] va fi:
   x[k] apartzine de la 1..n-sum

In felul acesta, orice combinatzie generata va fi valida
(suma NU mai are cum sa fie depashita)
*/
#include <iostream>
using namespace std;

int x[30],n;

int afish(int k)
{
    for(int i=1;i<=k;i++)
      cout<<x[i]<<" ";
    cout<<"\n";
}

void back(int k,int sum)
{
    int tz;
    for(x[k]=1;x[k]<=n-sum;x[k]++)
            if(sum+x[k]==n)
                        afish(k);
            else
                back(k+1,sum+x[k]);
}

int main()
{
    cin>>n;
    back(1,0);
    return 0;
}
