/**
    First, LAST Name: Alexandru GHITA
    Contest #1, Intermediate 3
    School: National College "Andrei Saguna" Brasov
    Input file: timesh.in
    Output file: timesh.out
**/

#include <stdio.h>
#include <ctype.h>

FILE *F = fopen("timesh.in", "r");
FILE *G = fopen("timesh.out", "w");

int location[3], daynumber[3], starth[3], endh[3];
char s1, e1, s2, e2;
double payment;

void read()
{
    fscanf(F, "%d %d %c %c", &location[1], &daynumber[1], &s1, &e1);
    fscanf(F, "%d %d %c %c", &location[2], &daynumber[2], &s2, &e2);
}

void prepare_data()
{
    location[1] = location[1] / 100;
    location[2] = location[2] / 100;
    if (isalpha(s1))
        starth[1] = s1 - '0' - 7;
    else
        starth[1] = s1 - '0';
    if (isalpha(s2))
        starth[2] = s2 - '0' - 7;
    else
        starth[2] = s2 - '0';
    if (isalpha(e1))
        endh[1] = e1 - '0' - 7;
    else
        endh[1] = e1 - '0';
    if (isalpha(e2))
        endh[2] = e2 - '0' - 7;
    else
        endh[2] = e2 - '0';
}

void solve()
{
    double workedh;
    payment = 0;
    for (int d = 1; d <= 2; d++)
    {
        workedh = (double)(endh[d] - starth[d]) / 2;
        if (location[d] == 1)
        {
            if (workedh <= 5)
                payment += workedh * 10;
            else
                payment += 50 + (workedh - 5) * 15;
        }
        else if (location[d] == 2)
        {
            if (workedh <= 6)
                payment += workedh * 7.5;
            else
                payment += 45 + (workedh - 6) * 15;
        }
        else if (location[d] == 3)
        {
            if (workedh <= 4)
                payment += workedh * 9.25;
            else
                payment += 37 + (workedh - 4) * 10.5;
        }
        else if (location[d] == 4)
        {
            if (daynumber[d] == 1 || daynumber[d] == 7)
                payment += workedh * 13.5;
            else
                payment += workedh * 6.75;
        }
        else if (location[d] == 5)
        {
            if (workedh <= 6)
                payment += workedh * 8;
            else
                payment += 48 + (workedh - 6) * 12;
        }
    }
}

void print()
{
    fprintf(G, "$%.2lf\n", payment);
}

int main()
{
    for (int line = 1; line <= 5; line++)
    {
        read();
        prepare_data();
        solve();
        print();
    }
    fclose(F);
    fclose(G);
    return 0;
}

