/**
First, LAST Name: Alexandru GHITA
School: National College "Andrei Saguna", Brasov, Romania
Division: Intermediate
Contest #2
Input file: cells.in
Output is on the screen
**/

#include <stdio.h>
#include <string.h>

FILE *F = fopen("cells.in", "r");

int n;
char operation[20], cell1[20], cell2[20];

void divide()
{
    fscanf(F, "%s\n", &cell1);
    strcpy(cell2, cell1 + 4);
    strcpy(cell2 + 4, cell1 + 4);
    for (int i = 0; i <= 3; i++)
        cell1[i + 4] = cell1[i];
    printf("%s and %s\n", cell1, cell2);
}

void add()
{
    int i;
    n = operation[3] - '0';
    fscanf(F, "%s\n", &cell1);
    for (i = 0; i < n; i++)
        cell2[i] = cell1[i];
    for (i = n; i < 2 * n; i++)
        cell2[i] = cell1[i - n];
    for (i = 2 * n; i < 8; i++)
        cell2[i] = cell1[i - n];
    printf("%s\n", cell2);
}

void subtract()
{
    int i;
    n = operation[8] - '0';
    fscanf(F, "%s\n", &cell1);
    strcpy(cell2, cell1 + n);
    strcat(cell2, cell1 + strlen(cell1) - n);
    printf("%s\n", cell2);
}

void unite()
{
    int i;
    fscanf(F, "%s %s\n", &cell1, &cell2);
    for (i = 4; i < strlen(cell1); i++)
        printf("%c", cell1[i]);
    for (i = 0 ; i < 4; i++)
        printf("%c", cell2[i]);
    printf("\n");
}

void intersect()
{
    int i;
    fscanf(F, "%s %s\n", &cell1, &cell2);
    for (i = 0; i < 2; i++)
        printf("%c", cell1[i]);
    for (i = strlen(cell1) - 2; i < strlen(cell1); i++)
        printf("%c", cell1[i]);
    for (i = 0; i < 2; i++)
        printf("%c", cell2[i]);
    for (i = strlen(cell2) - 2; i < strlen(cell2); i++)
        printf("%c", cell2[i]);
    printf("\n");
}

void read()
{
    fscanf(F, "%s ", &operation);
    if (!strcmp(operation, "DIVIDE"))
        divide();
    else if (operation[0] == 'A')
        add();
    else if (operation[0] == 'S')
        subtract();
    else if (!strcmp(operation, "UNION"))
        unite();
    else if (!strcmp(operation, "INTERSECT"))
        intersect();
}

int main()
{
    for (int line = 1; line <= 5 ; line++)
        read();
    fclose(F);
    return 0;
}
