/**
First, LAST Name: Alexandru GHITA
Contest #4, Intermediate 3
School Name: National College Andrei Saguna
Input File: rummy.in
Output File: rummy.out
**/

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cctype>

using namespace std;

/*
1 <- S
2 <- H
3 <- C
4 <- D
*/

ifstream fin("rummy.in");
ofstream fout("rummy.out");

int Winning_Hand[200][4], Losing_Hand[8][3], Score;

void Read_Winning_Hand()
{
    char c;
    for (int i = 1; i <= 7; i++)
    {
        fin >> c;
        if (isdigit(c))
            Winning_Hand[i][1] = c - '0';
        else if (c == 'A')
            Winning_Hand[i][1] = 1;
        else if (c == 'T')
            Winning_Hand[i][1] = 10;
        else if (c == 'J')
            Winning_Hand[i][1] = 11;
        else if (c == 'Q')
            Winning_Hand[i][1] = 12;
        else if (c == 'K')
            Winning_Hand[i][1] = 13;
        fin >> c;
        if (c == 'S')
        {
            Winning_Hand[i][2] = 1;
        }
        else if (c == 'H')
        {
            Winning_Hand[i][2] = 2;
        }
        else if (c == 'C')
        {
            Winning_Hand[i][2] = 3;
        }
        else if (c == 'D')
        {
            Winning_Hand[i][2] = 4;
        }
    }
}

void Read_Losing_Hand()
{
    char c;
    for (int i = 1; i <= 7; i++)
    {
        fin >> c;
        if (isdigit(c))
            Losing_Hand[i][1] = c - '0';
        else if (c == 'A')
            Losing_Hand[i][1] = 1;
        else if (c == 'T')
            Losing_Hand[i][1] = 10;
        else if (c == 'J')
            Losing_Hand[i][1] = 11;
        else if (c == 'Q')
            Losing_Hand[i][1] = 12;
        else if (c == 'K')
            Losing_Hand[i][1] = 13;
        fin >> c;
        if (c == 'S')
        {
            Losing_Hand[i][2] = 1;
        }
        else if (c == 'H')
        {
            Losing_Hand[i][2] = 2;
        }
        else if (c == 'C')
        {
            Losing_Hand[i][2] = 3;
        }
        else if (c == 'D')
        {
            Losing_Hand[i][2] = 4;
        }
        Losing_Hand[i][0] = 0;
        Winning_Hand[i][3] = 0;
    }
    for (int i = 8; i <= 15; i++)
    {
        Winning_Hand[i][1] = Winning_Hand[i][2] = Winning_Hand[i][3] = 0;
    }
}

void Add_Cards()
{
    int i, j, k, ok, nr = 7;
    do
    {
        ok = 0;
        for (i = 1; i <= 7; i++)
        {
            if (!Losing_Hand[i][0])
            {for (j = 1; j <= nr; j++)
            {
                if (abs(Winning_Hand[j][1] - Losing_Hand[i][1]) == 1 &&
                    Winning_Hand[j][2] == Losing_Hand[i][2] && Winning_Hand[j][3] != 2)
                    {
                        Losing_Hand[i][0] = 1;
                        Winning_Hand[++nr][1] = Losing_Hand[i][1];
                        Winning_Hand[nr][2] = Losing_Hand[i][2];
                        Winning_Hand[nr][3] = 1;
                        ok = 1;
                        break;
                    }
                else if (Losing_Hand[i][1] == Winning_Hand[j][1] && Winning_Hand[j][3] != 1)
                {
                    Losing_Hand[i][0] = 1;
                    Winning_Hand[++nr][1] = Losing_Hand[i][1];
                    Winning_Hand[nr][2] = Losing_Hand[i][2];
                    Winning_Hand[nr][3] = 2;
                    ok = 1;
                    break;
                }
            }}
        }
    }while(ok);
}

void Find_Score()
{
    Score = 0;
    for (int i = 1; i <= 7; i++)
    {
        if (!Losing_Hand[i][0])
        {
            if (Losing_Hand[i][1] <= 10)
            {
                Score += Losing_Hand[i][1];
            }
            else
            {
                Score += 10;
            }
        }
    }
}

void Print_Score()
{
    fout << Score << "\n";
}

void Marcare()
{
    int i, nr1 = 0, j, ref, cl;
    for (i = 1; i <= 7; i++)
    {

            if (Winning_Hand[i][1] - Winning_Hand[i - 1][1] == 1 &&
                Winning_Hand[i][2] == Winning_Hand[i - 1][2] && !Winning_Hand[i][3])
                Winning_Hand[i][3] = Winning_Hand[i - 1][3] = 1;
    }
    for (i =1; i <= 7; i++)
        if (Winning_Hand[i][3] == 1)
            nr1++;
    if (nr1 < 3)
    {
        for (i = 1; i <= 7; i++)
            Winning_Hand[i][3] = 0;
        for (i=1;i<=7;i++)
        {
            ref = Winning_Hand[i][1];
            cl = Winning_Hand[i][2];
            for (j=1;j<=7;j++)
            {
                if(Winning_Hand[i][1] == ref)
                    Winning_Hand[i][3] = 2;
            }
        }
        for (i = 1; i <= 7; i++)
        {

            if (Winning_Hand[i][1] - Winning_Hand[i - 1][1] == 1 &&
                Winning_Hand[i][2] == Winning_Hand[i - 1][2] && !Winning_Hand[i][3])
                Winning_Hand[i][3] = Winning_Hand[i - 1][3] = 1;
        }
    }
    else for (i = 1; i <= 7; i++)
        if (Winning_Hand[i][3] == 0)
           Winning_Hand[i][3] = 2;
}


int main()
{
    Read_Winning_Hand();
    for (int Line = 1; Line <= 5; Line++)
    {
        Read_Losing_Hand();
        Marcare();
        Add_Cards();
        Find_Score();
        Print_Score();
    }
    fin.close();
    fout.close();
    return 0;
}
