/**
    School: National College Andrei Saguna
    First, LAST: Octavian MOVILIANU
    Input File: chess.in
    Output File: chess.out
*/
#include <iostream>
#include <fstream>
using namespace std;

int a[10][10], x1, x2, y1, y2, n;

void marcat(int x, int y)
{
    int xp=0, yp=0, xn=0, yn=0;
    while(xp+x<=8 && xp<=n) xp++, a[xp+x][y]=1;
    while(yp+y<=8 && yp<=n) yp++, a[x][y+yp]=1;
    while(x-xn>=1 && xn<=n) xn++, a[x-xn][y]=1;
    while(y-yn>=1 && yn<=n) yn++, a[x][y-yn]=1;
    int i;
    for(i=1; i<=min(xp, yp); i++) a[x+i][y+i]=1;
    for(i=1; i<=min(xp, yn); i++) a[x+i][y-i]=1;
    for(i=1; i<=min(xn, yn); i++) a[x-i][y-i]=1;
    for(i=1; i<=min(xn, yp); i++) a[x-i][y+i]=1;
}

int main()
{
    ifstream fin ("chess.in");
    ofstream fout ("chess.out");
    int k=5, i, j, nr;

    while(k)
    {
        fin>>x1>>y1>>x2>>y2>>n; n--;
        a[x1][y1]=1; a[x2][y2]=1;

        marcat(x1, y1);
        marcat(x2, y2);

        nr=0;
        for(i=1; i<=8; i++)
            for(j=1; j<=8; j++)
            {
                if(a[i][j]==0)nr++;
                a[i][j]=0;
            }
        fout<<nr<<"\n"; k--;
    }
    return 0;
}
