/**
  Se dau doua fishiere nr1.txt shi nr2.txt
pline cu numere (!NU se anuntza in prealabil
numarul lor).
  Se garanteaza ca sunt date in ordine crescatoare.
Sa se afisheze pe ecran shirul obtzinut prin interclasare,
folosind un algoritm optim d.p.d.v atit al memoriei
kt shi al timpului de executare.
Ex:
nr1.txt
1 6 8 14 22
nr2.txt
2 4 7 9 10 34 35 36 37 38 39
=>
1 2 4 6 7 8 9 10 14 22 34 35 36 37 38 39

  Pt. a face alg. optim ca timp de executare,
bazindu-ne pe faptul ca cele doua fishiere contzin
numere sortate, vom utiliza algoritmul de interclasare.
  Nr. de pashi efectuatzi de acesta este dat de nr.
total de valori din cele doua fishiere.
  Deci ambele fishiere cu date de intrare
vor fi parcurse o singura data.

  Ca memorie alg. va fi optim deoarece nu utilizeaza vectori
ci doar citeva variabile simple.
===
  Partea delicata la transcrierea algoritmului pt. fishiere
consta in folosirea a doua flag-uri, pe care le initzializam
cu 1, shi care vor deveni 0 in momentul in care in fishierul
corespunzator s-a terminat citirea
*/
#include <iostream>
#include <fstream>
using namespace std;

int main()
{
    fstream f,g;
    f.open("f1.txt",ios::in);
    g.open("f2.txt",ios::in);
    int ok1=1,ok2=1,x,y;
    f>>x;
    g>>y;
    while(ok1 && ok2)
      if(x<y)
        {
            cout<<x<<" ";
            if(!(f>>x))//if-ul asta: daca mai are ce citi citeshte
                    ok1=0;//daca nu, ii da lui ok1 valoarea 0
        }
    else
        {
            cout<<y<<" ";
            if(!(g>>y))
                    ok2=0;
        }
    while(ok1)
    {
        cout<<x<<" ";
        if(!(f>>x))
                    ok1=0;
    }
    while(ok2)
    {
        cout<<y<<" ";
        if(!(g>>y))
                    ok2=0;
    }
    return 0;
}
