/**
 b) Transformam numarul in fractzie ratzionala, prin regula
cunoscuta (la numarator = nr. dat ori 10 la puterea nr. de zecimale,
la numitor = 10 la puterea nr. de zecimale) retzinind separat
numaratorul shi numitorul.
  Simplificam apoi cele doua prin cmmdc shi avem rezultatul.
Ex: 54.814 => numaratorul=54.814*1000 = 54814
            numitorul = 1000

  Obs: Deoarece numerele reale au neajunsul reprezentarii
aproximative in cazul anumitor valori, vom lucra cu stringuri:
  citim numarul dat sub forma de string.
Determinam pozitzia punctului - aceasta ne va da shi nr. de zecimale

 Alg. este eficient d.p.d.v. al memoriei deoarece NU se folosesc 
vectori, ci doar variabile simple
 Alg. este eficient d.p.d.v. al timpului de executare deoarece alg.
lui Euclid, folosit la calculul cmmdc, este eficient, facind un nr.
mic de pashi, iar in rest, pentru aflarea numaratorului shi a 
numitorului se face oricum un numar mic de pashi (cel mult 10)
*/
#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string.h>
using namespace std;
int main()
{
    char s[20],*p;
    int a,b,nz,pozp;
    ifstream fin("numar.txt");
    fin.getline(s,20);
    p=strchr(s,'.');
    if(p==NULL)nz=0;
    else {
          pozp=p-s;
          nz=strlen(s)-pozp-1;
          strcpy(s+pozp,s+pozp+1);//shtergem punctul
         }
    //convertim nr. din string in variabila a:
    a=atoi(s);
    //in b formez 10 la puterea pozp
    b=1;
    for(int i=1;i<=nz;i++) b*=10;
    int x,y,r;
    x=a;y=b;
    while(y)
        {
            r=x%y;
            x=y;
            y=r;
        }
    cout<<a/x<<" "<<b/x;
    return 0;
}
