/**
Optimizarea permutarilor : pentru a evita validarea lui x[k] folosind
un for, ne putem folosi de particularitatea ca nr. pe care trebuie
sa le validam sunt mici, de la 1 la n, prin urmare
putem sa folosim un vector de marcare, in care le marcam cu 1
pe cele folosite, cu 0 pe restul.
  Avem grija ca la intoarcerea de pe un nivel de backtracking pe
nivelul anterior sa "dez"marcam elementul.
*/
#include <iostream>
using namespace std;

int x[30],n,used[30];//asta fiind global e de la ma-sa initzializat cu 0

void afish()
{
    int i;
    for(i=1;i<=n;i++)
      cout<<x[i]<<" ";
    cout<<"\n";
}

void back(int k)
{
  for(x[k]=1 ; x[k]<=n ; x[k]++)
	if(!used[x[k]])//deci daca x[k] NU e folosit
	{
       used[x[k]]=1;//il marcam ca folosit
       if(k==n)
			afish();
       else
            back(k+1);
       used[x[k]]=0;//il "dez"marcam
     }
}
int main()
{
    cin>>n;
    back(1);
    return 0;
}
