/**
citim n.
Sa se genereze toate nr. in baza 10 cu cifre distincte,
a caror suma este n.

analiza:
  1. shirul de solutzii : bagam cifrele
     domenii:
        x[1] apartzine 1..min(n,9)
        x[2] apartzine 0..min(n-x[1],9)
        daca notam cu sum suma x[1]+..+x[k-1]
        x[k] apartzine 0..min(n-sum,9)

  2. valid: x[k] sa nu se repete printre alea de dinainte
                (cu vector de marcare)

  3. solutzie: sum+s[k]==n

  4. Cu prelungire
*/
#include <iostream>
using namespace std;

int x[12],n,used[12];

void afish(int k)
{
    for(int i=1;i<=k;i++)
      cout<<x[i];
    cout<<"\n";
}

void back(int k,int sum)
{
    for(x[k]=(k==1?1:0) ; x[k]<=min(n-sum,9); x[k]++)
        if(!used[x[k]])
            { used[x[k]]=1;
              if(sum+x[k]==n)
                        afish(k);
              back(k+1,sum+x[k]);
              used[x[k]]=0;
            }
}

int main()
{
    cin>>n;
    back(1,0);
    return 0;
}
