#include <iostream>
#include <fstream>
using namespace std;

int puteremodk(int x,int M,int K)
{
    //calculam (x^M)%k pe baza formulei care desface un produs
    //din care se calc. modulo, adik ((a*b)%k==(a%k)*(b%k))%k
    //pe linga asta, aplicam procedeul optim de calcul
    //a lui a^p, bazat pe faptul:
    //  daca p este par, a^p=(a^(p/2))*(a^(p/2))
    //  daca este impar, a^p=a^(p-1)*a, shi p-1 e din nou par shi
    //                                   se va putea aplica din nou
    //                                   injumatatzirea
    //Pentru asta luam un shir, vedem care e ordinea in care tre'
    //sa facem p=p*p sau p=p*a, shi facem apoi operatziile de la coada
    int a[100],ne=0;
    while(M>0)
    {
        if(M%2==0)
            {
                M/=2;
                a[++ne]=2;
            }
        else
            {
                M--;
                a[++ne]=1;
            }
    }
    int p,j;
    p=1;
    for(j=ne;j>=1;j--)
      if(a[j]==1)
            p=(p*(x%K))%K;
        else
            p=((p%K)*(p%K))%K;
    //in final in varibila p a ramas exact valoarea (x^M)%k
    return p;
}

int main()
{
    int N,M,K,x,i,p,nrv=0,j;
    ifstream fin("divk.in");
    fin>>N>>M>>K;
    for(i=1;i<=N;i++)
    {
        fin>>x;
        if(puteremodk(x,M,K)==0) nrv++;
    }
    ofstream fout("divk.out");
    fout<<nrv;
    fout.close();
    return 0;
}
