/**
  Stringuri = shiruri de caractere

Constante de tip string : text scris intre ghilimele

  Majoritatea functziilor pt. stringuri se afla in biblioteca
<string.h>

  Daca vrem sa le folosim ca shi variabile, acestea se declara
sub forma unui vector de char.
char s[10];

  Ce au particular: caracterele se memoreaza unul cite unul,
incepind de la indicele 0 (!fapt necontrolat de utilizator)
iar ca marca de final de string apare un caracter special,
numit caracterul nul, care are codul ASCII 0.
Ex:
char s[10]="DEC";
se memoreaza:
s[0] <-> caracterul 'D' (codul ASCII 68)
s[1] <-> caracterul 'E' (codul ASCII 69)
s[2] <-> caracterul 'C' (codul ASCII 67)
s[3] <-> caracterul '\0' (codul ASCII 0)

Obs: Tipul de atribuire, ca mai sus, prin operatorul "="
a unei valori catre un string se poate face DOAR in momentul
declararii.
  In orice alt moment, daca vretzi vreo astfel de atribuire,
tre' sa o inlocuitzi cu functzia
strcpy(variabila_string,valoare)
 valoare = fie ii zicem un alt string de unde sa ia caracterele,
           fie direct o constanta de tip string.

Lungimea unui string: functzia
strlen(string)
*/
#include <iostream>
#include <string.h>
using namespace std;

int main()
{
    char c[10]="DEC";
    cout<<c<<"\n";//afish. "DEC"
    cout<<c[0]<<" -> "<<(int)c[0]<<"\n";
    cout<<c[1]<<" -> "<<(int)c[1]<<"\n";
    cout<<c[2]<<" -> "<<(int)c[2]<<"\n";
    cout<<c[3]<<" -> "<<(int)c[3]<<"\n";
    strcpy(c,"elefant");
    cout<<c<<"\n";
    c[3]=0;
    cout<<c<<" -> cu lungimea:"<<strlen(c)<<"\n";
    c[3]='g';//!! c[3] e de tip char, deci i-am atrib. un char
    cout<<c<<" -> cu lungimea:"<<strlen(c)<<"\n";
    cout<<"Stringul parcurs pe for:\n";
    int i;
    for(i=0;i<strlen(c);i++)
            cout<<c[i]<<"\n";
    return 0;
}
