#include <cstdio>
#define maxq 1125100
using namespace std;

char a[1502][1502];
int n,m,il1,il2,jl1,jl2,pmq,umq,pq,uq,minpq;

short int mq[maxq][2],q[2250100][2];

void afish()
{
    int i,j;
    for(i=0;i<=n+1;i++)
    {
        for(j=0;j<=m+1;j++)
            printf("%c",a[i][j]);
        printf("\n");
    }
}

int ice_around(int i,int j)
{
    return (a[i-1][j]-'X')*(a[i+1][j]-'X')*
           (a[i][j-1]-'X')*(a[i][j+1]-'X')==0;
}

void melt()
{
    int uqaux=umq,ic,jc;
    while(pmq!=(uqaux+1)%maxq)
    {
        ic=mq[pmq][0];
        jc=mq[pmq][1];
        pmq=(pmq+1)%maxq;
        if(a[ic-1][jc]=='X')
        {
            a[ic-1][jc]='.';
            if(ice_around(ic-1,jc))
            {umq=(umq+1)%maxq;mq[umq][0]=ic-1;mq[umq][1]=jc;}
        }
        if(a[ic+1][jc]=='X')
        {
            a[ic+1][jc]='.';
            if(ice_around(ic+1,jc))
            {umq=(umq+1)%maxq;mq[umq][0]=ic+1;mq[umq][1]=jc;}
        }
        if(a[ic][jc-1]=='X')
        {
            a[ic][jc-1]='.';
            if(ice_around(ic,jc-1))
            {umq=(umq+1)%maxq;mq[umq][0]=ic;mq[umq][1]=jc-1;}
        }
        if(a[ic][jc+1]=='X')
        {
            a[ic][jc+1]='.';
            if(ice_around(ic,jc+1))
            {umq=(umq+1)%maxq;mq[umq][0]=ic;mq[umq][1]=jc+1;}
        }
    }
}

int drum()
{
    pq=minpq;
    minpq=-1;
    int ic,jc;
    while(pq<=uq)
    {
        ic=q[pq][0];jc=q[pq][1];
        if(minpq==-1 && ice_around(ic,jc))minpq=pq;
        if(ic==il2&&jc==jl2)return 1;
        pq++;
        if(a[ic-1][jc]=='.')
        {a[ic-1][jc]='L';uq++;q[uq][0]=ic-1;q[uq][1]=jc;}
        if(a[ic+1][jc]=='.')
        {a[ic+1][jc]='L';uq++;q[uq][0]=ic+1;q[uq][1]=jc;}
        if(a[ic][jc-1]=='.')
        {a[ic][jc-1]='L';uq++;q[uq][0]=ic;q[uq][1]=jc-1;}
        if(a[ic][jc+1]=='.')
        {a[ic][jc+1]='L';uq++;q[uq][0]=ic;q[uq][1]=jc+1;}
    }
    return 0;
}

int main()
{
    int i,j;
    FILE *f=fopen("lbd.in","r");
    fscanf(f,"%d%d\n",&n,&m);
    char c;
    for(j=0;j<=m+1;j++)a[0][j]=a[n+1][j]='B';
    for(i=1;i<=n;i++)
    {
        for(j=1;j<=m;j++)
        {
            a[i][j]=fgetc(f);
            if(a[i][j]=='L')
              if(il1==0){il1=i;jl1=j;a[i][j]='.';}
                else {il2=i;jl2=j;a[i][j]='.';}
        }
        a[i][0]=a[i][m+1]='B';
        fgetc(f);
    }
    //punem in coada de topire coord. tuturor elem. din matrice
    //care sunt apa shi au in vecinatatate gheatza
    pmq=0;umq=-1;
    for(i=1;i<=n;i++)
      for(j=1;j<=m;j++)
        if(a[i][j]=='.'&&ice_around(i,j))
            {
                mq[++umq][0]=i;
                mq[umq][1]=j;
            }
    int d=0;
    q[0][0]=il1;q[0][1]=jl1;a[il1][jl1]='L';
    while(!drum())
    {
        melt();
        d++;
    }
    f=fopen("lbd.out","w");
    fprintf(f,"%d",d);
    fclose(f);
    return 0;
}
