// Name: Octavian MOVILIANU
// Contest#1, intermediar 3
// School: National College "Andrei Saguna"
// Input file: timesh.in
// Output file: timesh.out
#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

/*  RULES:
    100- 199 -> $10 + $15 (over 5 hours)
    200- 299 -> $7,5 + $15 (over 6 hours)
    300- 399 -> $9.25 + $10,5 (over 4 hours)
    400- 499 -> $13,5 (day 1 & 7) or $6.75 (other days)
    500- 599 -> $8 + $12 (over 6 hours)
    Luam fiecare locatie intr-o functie separata, pe care o accesam prin if-uri.
*/
int l1, l2, d1, d2;
char h11, h12, h21, h22;
char c[20]={'1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E','F', 'G','H'};

int one(int a)
{
    if(a<500) return a*10;
    return (5000+(a-500)*15);
}

int two(int a)
{
    if(a<600) return a*75/10;
    else return 4500+(a-600)*15;
}

int three(int a)
{

    if(a<400) return a*925/100;
    else return 3700+(a-400)*105/10;
}

int four(int d, int a)
{
    if(d==1 || d==7) return a*135/10;
    else return a*675/100;
}

int five(int a)
{
    if(a<600) return a*8;
    else return 4800+(a-600)*12;
}

int time(char i, char o) // calculeaza cate ore lucreaza fiecare, timpul fiind inmultit cu 100
{
    int y, a, b;
    for(y=0; y<=16; y++)
    {
        if(c[y]==i) a=y;
        if(c[y]==o) b=y;
    }
    a=(b-a)*100/2;
    return a;
}

int main()
{
    ifstream iau ("timesh.in"); // pentru a aproxima mai usor numerelele dupa virgula, vom lucra cu
    ofstream dau ("timesh.out"); // timpi si sume inmultite cu 100 (ne trebuie doua numere dupa virgula)

    for(int i=1; i<=5; i++)
    {
        iau>>l1>>d1>>h11>>h12;
        iau>>l2>>d2>>h21>>h22;

        int a=time(h11, h12);

        int s=0;
        if(l1<=199) s+=one(a);
        else if(l1<=299) s+=two(a);
            else if(l1<=399) s+=three(a);
                else if(l1<=499) s+=four(d1, a);
                    else if(l1<=599)s+=five(a);


        a=time(h21, h22);

        if(l2<=199) s+=one(a);
        else if(l2<=299) s+=two(a);
            else if(l2<=399) s+=three(a);
                else if(l2<=499) s+=four(d2, a);
                    else if(l2<=599)s+=five(a);

        int x=s%100; s/=100; // salvam in x numerele care ar trebui sa fie dupa virgula
        if(x==0) dau<<"$"<<s<<".00\n"; // daca nu avem zecimale, trebuie sa le "fortam"
        else if(x/10==0)dau<<"$"<<s<<".0"<<x<<"\n"; //daca avem zecimale de genul .05
            else dau<<"$"<<s<<"."<<x<<"\n";
    }
    return 0;
}
