/**
School:National College Andrei Saguna
First,LAST Name: Gabriel Robert INELUS
Intermediate 3, Contest #3
Input file:chess.in
Output: Output is on the screen
*/
#include <cstdio>
#include <cstring>
FILE *f=fopen("chess.in","r");
int x1,y1,x2,y2,dist;
int board[9][9],total;
void mergistg(int i,int j)
{
    int times=1;
    while(j>1 && board[i][j-1]>=0 && times<=dist)
    {
        j--;
        times++;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void mergidr(int i,int j)
{
    int times=1;
    while(j<8 && board[i][j+1]>=0 && times<=dist)
    {
        times++;
        j++;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void mergisus(int i,int j)
{
    int times=1;
    while(i>1 && board[i-1][j]>=0 && times<=dist)
    {
        times++;
        i--;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void mergijos(int i,int j)
{
    int times=1;
    while(i<8 && board[i+1][j]>=0 && times<=dist)
    {
        times++;
        i++;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void mergistgsus(int i,int j)
{
    int times=1;
    while(i>1 && j>1 && board[i-1][j-1]>=0 && times<=dist)
    {
        times++;
        i--;
        j--;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void mergidrsus(int i,int j)
{
    int times=1;
    while(i>1 && j<8 && board[i-1][j+1]>=0 && times<=dist)
    {
        times++;
        i--;
        j++;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void mergistgjos(int i,int j)
{
    int times=1;
    while(i<8 && j>1 && board[i+1][j-1]>=0 && times<=dist)
    {
        times++;
        i++;
        j--;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void mergidrjos(int i,int j)
{
    int times=1;
    while(i<8 && j<8 && board[i+1][j+1]>=0 && times<=dist)
    {
        times++;
        i++;
        j++;
        if(board[i][j] == 0)
        {
            board[i][j]=1;
            total++;
        }
    }
}
void complete(int i,int j)
{
    mergistg(i,j);//left
    mergidr(i,j);//right
    mergisus(i,j);//up
    mergijos(i,j);//down

    mergistgsus(i,j);//left up
    mergidrsus(i,j);//right up

    mergistgjos(i,j);//left down
    mergidrjos(i,j);//right down

}
int main()
{
    int line;
    for(line=1;line<=5;line++)
    {
        total=0;
        memset(board,0,sizeof(board));
        fscanf(f,"%d%d%d%d%d",&x1,&y1,&x2,&y2,&dist);
        board[x1][y1]=-1;
        board[x2][y2]=-1;
        complete(x1,y1);
        complete(x2,y2);
        if(x1==x2 && y1==y2)
            total+=1;//same place
        else
            total+=2;//2 diff places
        printf("%d\n",64-total);
    }
    return 0;
}
